Create, read, update, and delete tasks. Tasks belong to goals or can be subtasks of other tasks.
/api/v1/tasksread:tasksRetrieve a paginated list of tasks for your team.
pageintegerPage number (default: 1)limitintegerItems per page (default: 50, max: 100)statusstringFilter by status: to_do, in_progress, completed, on_hold, blocked, in_reviewprioritystringFilter by priority: low, medium, high, urgentassigned_touuidFilter by assignee user IDgoal_iduuidFilter by parent goal IDparent_task_iduuidFilter by parent task ID (for subtasks)typestringFilter by type: task, sub_task, bug, story, epicsort_bystringSort field (default: created_at)sort_orderstringSort direction: asc or desc (default: desc)curl -X GET "https://gateway.thekairos.app/v1/tasks?status=in_progress&limit=10" \
-H "Authorization: Bearer YOUR_API_KEY"{
"data": [
{
"id": "550e8400-e29b-41d4-a716-446655440000",
"team_id": "123e4567-e89b-12d3-a456-426614174000",
"goal_id": "789e0123-e45b-67d8-a901-234567890000",
"title": "Implement user authentication",
"description": "Add OAuth2 login flow",
"type": "task",
"status": "in_progress",
"priority": "high",
"assigned_to": "456e7890-e12b-34d5-a678-901234567000",
"due_date": "2024-01-15",
"story_points": 5,
"created_at": "2024-01-01T00:00:00Z",
"updated_at": "2024-01-05T10:30:00Z"
}
],
"pagination": {
"page": 1,
"limit": 10,
"total": 42,
"has_more": true
}
}/api/v1/tasks/:idread:tasksRetrieve a single task by ID.
curl -X GET "https://gateway.thekairos.app/v1/tasks/550e8400-e29b-41d4-a716-446655440000" \
-H "Authorization: Bearer YOUR_API_KEY"{
"data": {
"id": "550e8400-e29b-41d4-a716-446655440000",
"team_id": "123e4567-e89b-12d3-a456-426614174000",
"goal_id": "789e0123-e45b-67d8-a901-234567890000",
"title": "Implement user authentication",
"description": "Add OAuth2 login flow with Google and GitHub providers",
"type": "task",
"status": "in_progress",
"priority": "high",
"estimated_hours": 8,
"actual_hours": 4,
"assigned_to": "456e7890-e12b-34d5-a678-901234567000",
"created_by": "789e0123-e45b-67d8-a901-234567890000",
"due_date": "2024-01-15",
"start_date": "2024-01-10",
"story_points": 5,
"metadata": {},
"created_at": "2024-01-01T00:00:00Z",
"updated_at": "2024-01-05T10:30:00Z"
}
}/api/v1/taskswrite:tasksCreate a new task. Must belong to a goal or be a subtask.
titlestringrequiredTask titledescriptionstringTask descriptiongoal_iduuidParent goal ID (required if no parent_task_id)parent_task_iduuidParent task ID for subtaskstypestringTask type (default: task)statusstringInitial status (default: to_do)prioritystringPriority level (default: medium)assigned_touuidAssignee user IDdue_datedateDue date (ISO 8601)start_datedateStart date (ISO 8601)estimated_hoursnumberEstimated hoursstory_pointsnumberStory points estimatemetadataobjectCustom metadatacurl -X POST "https://gateway.thekairos.app/v1/tasks" \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d '{
"title": "Implement user authentication",
"description": "Add OAuth2 login flow",
"goal_id": "789e0123-e45b-67d8-a901-234567890000",
"priority": "high",
"due_date": "2024-01-15",
"story_points": 5
}'{
"data": {
"id": "550e8400-e29b-41d4-a716-446655440000",
"team_id": "123e4567-e89b-12d3-a456-426614174000",
"goal_id": "789e0123-e45b-67d8-a901-234567890000",
"title": "Implement user authentication",
"description": "Add OAuth2 login flow",
"type": "task",
"status": "to_do",
"priority": "high",
"due_date": "2024-01-15",
"story_points": 5,
"created_at": "2024-01-10T15:30:00Z",
"updated_at": "2024-01-10T15:30:00Z"
}
}goal_id) or be a subtask of another task (via parent_task_id). You cannot create orphan tasks./api/v1/tasks/:idwrite:tasksUpdate an existing task. Only provided fields will be modified.
titlestringTask titledescriptionstringTask descriptionstatusstringTask statusprioritystringPriority levelassigned_touuidAssignee user ID (null to unassign)due_datedateDue date (null to clear)start_datedateStart dateestimated_hoursnumberEstimated hoursactual_hoursnumberActual hours spentstory_pointsnumberStory pointsmetadataobjectCustom metadatacurl -X PATCH "https://gateway.thekairos.app/v1/tasks/550e8400-e29b-41d4-a716-446655440000" \
-H "Authorization: Bearer YOUR_API_KEY" \
-H "Content-Type: application/json" \
-d '{
"status": "completed",
"actual_hours": 6
}'{
"data": {
"id": "550e8400-e29b-41d4-a716-446655440000",
"title": "Implement user authentication",
"status": "completed",
"actual_hours": 6,
"completed_at": "2024-01-12T14:00:00Z",
"updated_at": "2024-01-12T14:00:00Z"
}
}/api/v1/tasks/:idwrite:tasksPermanently delete a task and all its subtasks.
curl -X DELETE "https://gateway.thekairos.app/v1/tasks/550e8400-e29b-41d4-a716-446655440000" \
-H "Authorization: Bearer YOUR_API_KEY"{
"data": {
"deleted": true
}
}Tasks can have one of the following statuses:
| Status | Description |
|---|---|
to_do | Task has not been started |
in_progress | Task is actively being worked on |
in_review | Task is complete and awaiting review |
on_hold | Task is paused |
blocked | Task cannot proceed due to dependencies |
completed | Task has been finished |
archived | Task has been archived |